require 'net/http'

module Refltr

class Facebook

  # Local path to the test file
	FILE  = '/var/www/fb/test.html'

  # Remote path to the test file
	URL   = 'http://apps.facebook.com/XXXXXXXX/test.html'

  # Application id
	APPID = 'XXXXXXXXXX'

  # Application API key
	API_KEY = 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'

  # Facebook user credentials
	USERID = 'XXXXXXXXX'

  # Get the autnetication cookie from your browser
	COOKIES = 'c_user=XXXXXXXXX; xs=XXXXXXXXXXXXXXXXXXXXXXXXX'
 
  # User agent
	USER_AGENT = 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11'


	def test_fbml(input)
		
		# Write the HTML file

		File.open(Facebook::FILE, File::CREAT|File::TRUNC|File::WRONLY, 0644) { |file|
			file.binmode
			file.write(input)
		}

		# Send the request

		body = ''

		uri = URI.parse(Facebook::URL)

		Net::HTTP.new(uri.host, uri.port).start { |http|
			request = Net::HTTP::Get.new(uri.request_uri)
			request.add_field('User-Agent', Facebook::USER_AGENT)
			request.add_field('Cookie', Facebook::COOKIES)

			response = http.request(request)
			case response
			when Net::HTTPSuccess
				body = response.body
			else
				response.error!
			end
		}

		# Look for errors

		match = /<h2>Errors while loading page from application<\/h2>(.*)<p>There are still a few kinks Facebook and the makers of /m.match(body)

		errors = nil
		if match
			errors = match[1]
			errors.gsub!("<pre>", "\n<pre>");
		end

		# Parse the request
		
		match = /<div id="app_content_#{Facebook::APPID}" class="app_content_#{Facebook::APPID} canvas_rel_positioning"><div>(.*)(<\/div><\/div><div style="padding: 10px;"><h2>Errors while loading page from application<\/h2>|<\/div><\/div><div style="padding:10px;"><a href="#" onclick="report_public_canvas_page_dialog\(#{Facebook::APPID}\);">Report this application<\/a><\/div>|<\/div><\/div><\/div><\/div><\/div><div id="pagefooter" class="clearfix">)/m.match(body)

		result = nil
		if match
			result = match[1]
		else
			raise Facebook::Error.new(body, errors)
		end

		return Facebook::Result.new(body, result, errors)
	end
end

class Facebook::Error < StandardError
	attr_reader :body
	attr_reader :errors

	def initialize(body, errors)
		@body = body
		@errors = errors
	end
end

class Facebook::Result
	attr_reader :body
	attr_reader :result
	attr_reader :errors

	def initialize(body, result, errors)
		@body = body
		@result = result
		@errors = errors
	end
end

end
